Summary: GNU ADA 95 Compiler
Vendor: The White Raven Institute
Distribution: Individual
Name: gnat
Version: 3.10p
Release: 1
Source1: ftp://wuarchive.wustl.edu/languages/ada/compilers/gnat/distrib/gnat-3.10p-i386-linux-bin.tar.gz
Source2: ftp://wuarchive.wustl.edu/languages/ada/compilers/gnat/distrib/gnat-3.10p-docs.tar.gz
Patch1: gnat.config
Patch2: gnat.glibc.patch
Copyright: GNU
Group: Development/Languages/ADA

%description
GNAT is the GNU ADA 95 translator.  It includes a revised gcc with
ADA support, as well as appropriate utilities and compilers.  Examples
are included in the doc directory.

This version is configured to use non-standard directories to avoid
conflicts with the standard GCC.  See README.redhat for details.

%prep
%setup -n gnat-3.10p-i386-linux-bin -T -b 1
%patch1 -p1
%patch2 -p1
%setup -n gnat-3.10p-i386-linux-bin -D -T -a 2
cat >README.redhat <<EOF
This version of GNAT has been especially configured for RedHat Linux 5.0.
Because I've had problems with previous versions conflicting with the
standard GCC (particularly, the GNAT GCC would not properly build a
kernel), I've configured it to install in non-standard directories.
In order to use it, you will need to place "/usr/local/gnat/bin" at
the beginning of your PATH so the GNAT GCC is found first.  You will
also need to source the file "/usr/local/gnat/etc/env-vals" for csh,
or "/usr/local/gnat/env-vals.sh" for bash in order to use the correct
libraries and executables.  This can be accomplished by the following
commands (for bash):

   export PATH=/usr/local/gnat/bin:$PATH
   . /usr/local/gnat/etc/env-vals.sh

The /usr/local/gnat/examples directory contains some example source
for you to try.
EOF

%build
GCC_EXEC_PREFIX=/usr/src/redhat/BUILD/gnat-3.10p-i386-linux-bin
export GCC_EXEC_PREFIX
ADA_INCLUDE_PATH=/usr/src/redhat/BUILD/gnat-3.10p-i386-linux-bin/rts-fsu/adainclude
export ADA_INCLUDE_PATH
ADA_OBJECTS_PATH=/usr/src/redhat/BUILD/gnat-3.10p-i386-linux-bin/rts-fsu/adalib
export ADA_OBJECTS_PATH
LD_RUN_PATH=/usr/src/redhat/BUILD/gnat-3.10p-i386-linux-bin/rts-fsu/adalib
export LD_RUN_PATH
C_INCLUDE_PATH=/usr/src/redhat/BUILD/gnat-3.10p-i386-linux-bin/ginclude
export C_INCLUDE_PATH
PATH=/usr/src/redhat/BUILD/gnat-3.10p-i386-linux-bin:$PATH

cat >compile.sh <<EOF
cd adalib
echo Rebuilding GNAT libraries...
for file in ../adainclude/*.ad[bs] ; do
  echo '--->' \$file
  xgcc -c -O2 -gnatpga -I- \$file 2>\&1 >/dev/null
done
ar rv libgnat.a *.o
exit 0
EOF

cd rts-fsu
sh ../compile.sh

ADA_INCLUDE_PATH=/usr/src/redhat/BUILD/gnat-3.10p-i386-linux-bin/rts-native/adainclude
export ADA_INCLUDE_PATH
ADA_OBJECTS_PATH=/usr/src/redhat/BUILD/gnat-3.10p-i386-linux-bin/rts-native/adalib
export ADA_OBJECTS_PATH
LD_RUN_PATH=/usr/src/redhat/BUILD/gnat-3.10p-i386-linux-bin/rts-native/adalib
export LD_RUN_PATH
C_INCLUDE_PATH=/usr/src/redhat/BUILD/gnat-3.10p-i386-linux-bin/ginclude
export C_INCLUDE_PATH

cd ../rts-native
sh ../compile.sh

rm ../compile.sh

%install
sh ./doinstall
install -d /usr/local/gnat/etc /usr/local/gnat/examples
cp env-vals env-vals.sh /usr/local/gnat/etc
cp examples/* /usr/local/gnat/examples
cp /usr/lib/gcc-lib/i386-redhat-linux/2.7.2.3/*.o \
   /usr/lib/gcc-lib/i386-redhat-linux/2.7.2.3/SYSCALLS.c.X \
   /usr/local/gnat/lib/gcc-lib/i386-linux/2.7.2.1

%files
/usr/local/gnat
%doc COPYING COPYING.LIB
%doc README README.TASKING README.redhat
%doc features
%doc gnat-3.10p-docs/*
